package net.java.dev.fwutil.demoapp;

import java.awt.event.ActionEvent;

import javax.swing.JMenuItem;
import javax.swing.WindowConstants;

import net.java.dev.fwutil.Labels;
import net.java.dev.fwutil.Log;
import net.java.dev.fwutil.gui.BMFile;
import net.java.dev.hvlayout.AddressBookDemo;
import net.java.dev.hvlayout.TableHeaderDemo;
import net.java.dev.hvlayout.TestUI;

public class DMFile extends BMFile {

	private static final long serialVersionUID = 2488971446288052768L;

	public DMFile(DMainWindow mainWindow) {
		super(mainWindow);
		Log.log("DFile menu items initiated");
	}
	
	/** Override to add your own menu-items. */
	public void addMenuItems() {
		
		JMenuItem m;
		m = new JMenuItem(Labels.get(DMLabel.OpenAddressBook));
		m.setActionCommand(DMLabel.OpenAddressBook);
		m.addActionListener(this);
		add(m);
		m = new JMenuItem(Labels.get(DMLabel.OpenTestUI));
		m.setActionCommand(DMLabel.OpenTestUI);
		m.addActionListener(this);
		add(m);
		m = new JMenuItem(Labels.get(DMLabel.OpenTableTest));
		m.setActionCommand(DMLabel.OpenTableTest);
		m.addActionListener(this);
		add(m);
		addSeparator();

		Log.log("DFile menu items loaded");
		super.addMenuItems();
	}
	
	/** Override to catch your own action events from menu items. */
	public void actionPerformed(ActionEvent ae) {
		
		final String ac = ae.getActionCommand();
		if (DMLabel.OpenTestUI == ac) {
			javax.swing.SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					TestUI.main(new String[] {});
					TestUI.frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
				}
			});

		} else if (DMLabel.OpenTableTest == ac) {
			javax.swing.SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					new TableHeaderDemo().getFrame()
						.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
				}
			});
		} else if (DMLabel.OpenAddressBook == ac) {
			javax.swing.SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					final AddressBookDemo screen = new AddressBookDemo("Address Book Demo");
					screen.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
					screen.setVisible(true);
				}
			});
		} else {
			super.actionPerformed(ae);
		}
	}

}
