/*
 * This software is licensed under the GNU Lesser GPL, see
 * http://www.gnu.org/licenses/ for details.
 * You can use this free software in commercial and non-commercial products,
 * as long as you give credit to this software when you use it.
 * This softwware is provided "as is" and the use of this software is 
 * completely at your own risk, there are absolutely no warranties.
 * 
 */

package net.java.dev.fwutil;

/**
 * Defines a restart method.
 * Used by StartUp to restart the application.
 * @author Fred
 *
 */
public interface Restartable {
	/**
	 * The method that is called after all closing and
	 * clearing operations have been done by StartUp.close.
	 * @param args The parameters from the main method.
	 */
	public void restart(String[] args);
}
