package net.java.dev.fwutil;

import java.util.Iterator;
import java.util.concurrent.Executors;
import java.util.concurrent.ThreadPoolExecutor;

/** Executes added tasks one by one. Can remove tasks with a certain batchId from the queue. */ 
public class TaskQueue {
	
	private final ThreadPoolExecutor syncTask = (ThreadPoolExecutor) Executors.newFixedThreadPool(1);
	
	public void clear(final String batchId) {
		
		final Iterator<Runnable> tasks = syncTask.getQueue().iterator();
		while (tasks.hasNext()) {
			QTask t = (QTask) tasks.next();
			if (t.batchId == batchId || (t.batchId != null && t.batchId.equals(batchId))) {
				syncTask.remove(t);
			}
		}
	}
	
	public void remove(final QTask t) {
		syncTask.remove(t);
	}
	
	public void add(final QTask t) {
		syncTask.execute(t);
	}

}
