/*
 * This software is licensed under the GNU Lesser GPL, see
 * http://www.gnu.org/licenses/ for details.
 * You can use this free software in commercial and non-commercial products,
 * as long as you give credit to this software when you use it.
 * This softwware is provided "as is" and the use of this software is 
 * completely at your own risk, there are absolutely no warranties.
 * 
 */

package net.java.dev.fwutil;

import java.lang.Thread.UncaughtExceptionHandler;



/**
 * This class can be used to redirect the uncaught exceptions (runtime exceptions)
 * to the screen and log-file (see comments in StartUp.boot()). 
 * Unfortunately, initialization exceptions disappear in a black hole. 
 * The same could be true for other exceptions,
 * hence this should not be used in debug-mode.
 * The LogJavaSystem class provides a more robust solution.
 */
public class UtilExceptionHandler implements UncaughtExceptionHandler {
	
	public void uncaughtException(Thread t, Throwable e) {
		UIMessages.showErrorMessage(null, Labels.get("UnexpectedError"), e);
	}
}
