package net.java.dev.fwutil.pf.ui.menu;

import javax.swing.JMenuBar;

import net.java.dev.fwutil.gui.BMWindow;
import net.java.dev.fwutil.gui.IMainMenu;
import net.java.dev.fwutil.pf.ui.BrowsePanel;
import net.java.dev.fwutil.pf.ui.MainWindow;

public class MainMenu extends JMenuBar implements IMainMenu{

	private static final long serialVersionUID = -8693634146427159748L;
	
	MFile fileMenu;
	MView viewMenu;
	MBookmarks bookmarksMenu;
	BMWindow windowMenu;
	
	public MainMenu(MainWindow mainWindow, final BrowsePanel browsePanel) {
		
		fileMenu = new MFile(mainWindow, browsePanel);
		add(fileMenu);
		viewMenu = new MView(mainWindow, browsePanel);
		add(viewMenu);
		bookmarksMenu = new MBookmarks(mainWindow, browsePanel.getLocation());
		add(bookmarksMenu);
		windowMenu = new BMWindow(mainWindow); 
		add(windowMenu);
	}
	
	public boolean isClearSettingsSelected() {
		return fileMenu.deleteSettingsSelected();
	}
}
