package nl.intercommit.mario.tools.jbossmon;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

import net.java.dev.fwutil.LogUI;

public class ServerMonMenu implements ActionListener {

	private final JbServerMon serverMonWindow;
	private final JMenuBar menuBar;
	private final JMenuItem mconnect;
	private final JMenuItem mresetcounters;
	private final JMenuItem mclose;
	private final JMenuItem mexit;
	private final JMenuItem mrefreshq;
	private final JMenuItem mclearavg;
	private final JMenuItem mshowLog;
	private final JMenuItem mselectfont;
	private final JMenuItem msendmsg;
	private final JMenuItem mbrowseg;
	private final JMenuItem mdeployq;
	private final JMenuItem mdestroyq;
	private final JMenuItem mclearq;
	private final JCheckBoxMenuItem mdisableMStats;

	public ServerMonMenu(final JbServerMon serverMonWindow) {

		super();
		this.serverMonWindow = serverMonWindow;
		menuBar = new JMenuBar();
		JMenu menu = new JMenu("Server");
		menu.setMnemonic(KeyEvent.VK_S);
		mconnect = new JMenuItem("Open connection ...", KeyEvent.VK_O);
		mconnect.addActionListener(this);
		mconnect.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
		menu.add(mconnect);
		mresetcounters = new JMenuItem("Reset counters", KeyEvent.VK_R);
		mresetcounters.addActionListener(this);
		menu.add(mresetcounters);
		mdisableMStats = new JCheckBoxMenuItem("Disable server message statistics on close");
		mdisableMStats.setMnemonic(KeyEvent.VK_D);
		mdisableMStats.addActionListener(this);
		menu.add(mdisableMStats);
		mclose = new JMenuItem("Close connection", KeyEvent.VK_C);
		mclose.addActionListener(this);
		menu.add(mclose);
		menu.addSeparator();
		mexit = new JMenuItem("Exit program", KeyEvent.VK_X);
		mexit.addActionListener(this);
		mexit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.ALT_MASK));
		menu.add(mexit);
		menuBar.add(menu);
		menu = new JMenu("View");
		menu.setMnemonic(KeyEvent.VK_V);
		mrefreshq = new JMenuItem("Refresh queue list", KeyEvent.VK_R);
		mrefreshq.addActionListener(this);
		mrefreshq.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F5, 0));
		menu.add(mrefreshq);
		mclearavg = new JMenuItem("Reset averages", KeyEvent.VK_R);
		mclearavg.addActionListener(this);
		menu.add(mclearavg);
		menu.addSeparator();
		mshowLog = new JMenuItem("Show log", KeyEvent.VK_L);
		mshowLog.addActionListener(this);
		menu.add(mshowLog);
		mselectfont = new JMenuItem("Select display font and font size", KeyEvent.VK_L);
		mselectfont.addActionListener(this);
		menu.add(mselectfont);
		menuBar.add(menu);
		menu = new JMenu("Queue");
		menu.setMnemonic(KeyEvent.VK_Q);
		mbrowseg = new JMenuItem("Browse queue ...", KeyEvent.VK_B);
		mbrowseg.addActionListener(this);
		mbrowseg.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_B, ActionEvent.CTRL_MASK));
		menu.add(mbrowseg);
		msendmsg = new JMenuItem("Send message to queue ...", KeyEvent.VK_S);
		msendmsg.addActionListener(this);
		msendmsg.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
		menu.add(msendmsg);
		mdeployq = new JMenuItem("Deploy queue", KeyEvent.VK_C);
		mdeployq.addActionListener(this);
		menu.add(mdeployq);
		menu.addSeparator();
		mclearq = new JMenuItem("Clear ALL messages on queue", KeyEvent.VK_C);
		mclearq.addActionListener(this);
		menu.add(mclearq);
		mdestroyq = new JMenuItem("Destroy queue", KeyEvent.VK_C);
		mdestroyq.addActionListener(this);
		menu.add(mdestroyq);
		menuBar.add(menu);
	}

	public JMenuBar getJMenuBar() {
		return menuBar;
	}

	public void actionPerformed(final ActionEvent ae) {

		if (ae.getSource() == mconnect) {
			JbossConnect.showWindow();
		} else if (ae.getSource() == mclose) {
			serverMonWindow.dispose();
		} else if (ae.getSource() == mexit) {
			LogUI.close();
		} else if (ae.getSource() == mshowLog) {
			LogUI.makeVisible();
		} else if (ae.getSource() == mrefreshq) {
			serverMonWindow.refreshQueueList();
		} else if (ae.getSource() == mbrowseg) {
			serverMonWindow.openQueueBrowser();
		} else if (ae.getSource() == msendmsg) {
			serverMonWindow.openSendMsg();
		} else if (ae.getSource() == mclearq) {
			serverMonWindow.clearQueue();
		} else if (ae.getSource() == mresetcounters) {
			serverMonWindow.resetCounters();
		} else if (ae.getSource() == mdisableMStats) {
			serverMonWindow.disableMsgStats(mdisableMStats.getState());
		} else if (ae.getSource() == mclearavg) {
			serverMonWindow.resetAverages();
		} else  if (ae.getSource() == mdeployq) {
			serverMonWindow.deployQueue();
		} else if (ae.getSource() == mdestroyq) {
			serverMonWindow.destroyQueue();
		}  else if (ae.getSource() == mselectfont) {
			net.java.dev.fwutil.FontSelector.show(serverMonWindow);
		}
	}
}
